//+------------------------------------------------------------------+
//|                                                   History_EA.mq4 |
//|                                                               Me |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Me"
#property link      ""
#property version   "1.00"
#property strict
//Fast_EMA=iMA(NULL,0,Fast_MA_Period,0,MODE_EMA,PRICE_CLOSE,0);
extern double LotSize       = 0.1;
extern int    MagicNumber   = 198912;
extern int    TakeProfit_1  = 10;
extern int    TakeProfit_2  = 30;
extern int    TakeProfit_3  = 40;
extern int    StopLoss      = 20;
extern double TrailingStart = 20;
extern double TrailingStep  = 2;
extern double TrailingStop  = 10;
extern double BreakEvenStart= 10;
extern double BreakEven     = 1;
extern int    Slippage      = 3;
extern double Value_Diff    = 0.0003;
extern int    Fast_MA_Period= 10;
extern int    Slow_MA_Period= 40;
extern int    Indicators_Shift=1;
input  ENUM_MA_METHOD      Fast_MA_Mode   = MODE_EMA;
input  ENUM_MA_METHOD      Slow_MA_Mode   = MODE_EMA;
input  ENUM_APPLIED_PRICE  Fast_MA_Price  = PRICE_CLOSE;
input  ENUM_APPLIED_PRICE  Slow_MA_Price  = PRICE_CLOSE;
input  bool   UseRsiFilter=false;
//---
datetime recentClosedOrderTime=0;
int recentClosedTicket=-1;
int recentClosedOrderType=-1;
int myOrdersFromHistory=0;
int iOrderType_Buy  =0;
int iOrderType_Sell =1;
int BuyOrder;
int SellOrder;
int BuyOrder_1,BuyOrder_2,BuyOrder_3,BuyOrder_4;
int SellOrder_1,SellOrder_2,SellOrder_3,SellOrder_4;
double ticket_buy_3=0,ticket_sell_3=0;
int Buy_Ticket_3=0,Sell_Ticket_3=0,Buy_Ticket_4=0,Sell_Ticket_4=0;
int iOpenOrders_Sell=0,iOpenOrders_Buy=0;
int ticketNumber=-1;
int cnt=0;
double dPip;
double dStopLossPrice,dTakeProfitPrice;
double rsi=0;
//---
bool cond1=false,cond2=false,cond3=false,cond4=false,cond5=false;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {

//---

//---
   return(0);

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {

//---
   return(0);

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   dPip=Point;
   if(Digits==3 || Digits==5)dPip=Point*10;
//---
   double Fast_EMA=0,Slow_SMA=0,MA_Difference_1=0,MA_Difference_2=0;
   int open3BuyOrders=0;
//count open buy orders & open sell orders.
   iOpenOrders_Buy=CntOrd(OP_BUY);
   iOpenOrders_Sell=CntOrd(OP_SELL);
//---
   if(iOpenOrders_Buy>0 || iOpenOrders_Sell>0) Trailing_Stop();
//---
   Fast_EMA=iMA(NULL,0,Fast_MA_Period,0,Fast_MA_Mode,Fast_MA_Price,Indicators_Shift);
   Slow_SMA=iMA(NULL,0,Slow_MA_Period,0,Slow_MA_Mode,Slow_MA_Price,Indicators_Shift);
   rsi=iRSI(NULL,0,14,PRICE_CLOSE,Indicators_Shift);
//
   MA_Difference_1=Fast_EMA-Slow_SMA;
   MA_Difference_2=Slow_SMA-Fast_EMA;
//--- conditions for buy
   cond1=false;cond2=false;cond3=false;cond4=false;cond5=false;// reset all conditions
   if(Fast_EMA>Slow_SMA)cond1=true;
   if(MA_Difference_1>=Value_Diff)cond2=true;
   if(!UseRsiFilter)cond3=true;
   if(UseRsiFilter && rsi>50)cond3=true;
//---
//Checking for Buy Conditions
   if(cond1 && cond2)
     {
      if(cond3 && iOpenOrders_Buy<1)
        {
         //conditions for buy are met. Close any sell orders
         if(iOpenOrders_Sell>0)
           {
            bool bOrderClosed=CloseOrders(iOrderType_Sell);
            if(!bOrderClosed)//order was not closed.
              {
               Print((string)iOpenOrders_Sell+" sell orders still open . "+"Error closing sell order , error : "+(string)GetLastError());
               return;//don't place any more orders while orders are not closed
              }
            else Print("All Sell Order Closed");
           }
         //End - Close open sell positions
         // update sell orders count
         iOpenOrders_Sell=CntOrd(OP_SELL);
         iOpenOrders_Buy=CntOrd(OP_BUY);
         //---
         ticketNumber=History_Calling();//if no history orders, History_Calling will return 0

         if(ticketNumber<0)// check for errors on order selected from history
           {
            Print("Check buy conditions - There was an error selecting orders from history !");
            return;
           }
         //---

         if(recentClosedOrderType==1 && iOpenOrders_Buy<1)//last closed order was sell 
           {
            Print("Last order was Sell and Now Buy condition is met, so time to Open a Three Buy Order");
            open3BuyOrders=Three_Buy_Orders();
            if(open3BuyOrders>0)
              {
               Print("Three Buy Orders failed with error : "+(string)GetLastError());
               return;
              }
            else
              {
               open3BuyOrders=3-open3BuyOrders;
               Print("The "+(string)open3BuyOrders+" Buy Orders are Opened");
               return;
              }
           }
         //--- update sell orders count
         ticketNumber=History_Calling();
         iOpenOrders_Sell=CntOrd(OP_SELL);
         iOpenOrders_Buy=CntOrd(OP_BUY);
         //---     
         if((recentClosedOrderType==0 || (Buy_Ticket_3==0 && Buy_Ticket_4==0)) && iOpenOrders_Buy<1)//last open order was buy and no open orders now
           {
            Print("The Buy Condition is Still Valid, so time to Open a Single Buy Order");
            One_Buy_Orders();
            if(CntOrd(OP_BUY)>0)
              {
               Print("A Single Buy Order was Opened");
               return;
              }
            else Print("Failed to open one_buy order with error : "+(string)GetLastError());
           }

        }
     }
//Checking Sell Conditions
// update orders count
   iOpenOrders_Sell=CntOrd(OP_SELL);// update sell orders count
   iOpenOrders_Buy=CntOrd(OP_BUY);
//--- conditions for buy
   cond1=false;cond2=false;cond3=false;cond4=false;cond5=false;// reset all conditions
   if(Fast_EMA<Slow_SMA)cond1=true;
   if(MA_Difference_2>=Value_Diff)cond2=true;
   if(!UseRsiFilter)cond3=true;
   if(UseRsiFilter && rsi<50)cond3=true;
//---
   if(cond1 && cond2)
     {
      if(cond3 && iOpenOrders_Sell<1)
        {
         //Closing Opened Buy Orders   
         if(iOpenOrders_Buy>0)
           {
            bool bOrderClosed=CloseOrders(iOrderType_Buy); //Closing Buy order	
            if(bOrderClosed)
              {
               Print("Opened Buy order got closed");
              }
            else
              {
               Print("1 Error closing Opened Buy Orders, error : "+(string)GetLastError());
               return;// exit if buy order was not closed
              }
           }//end if(iOpenOrders_Buy > 0) 

         ticketNumber=History_Calling();

         if(ticketNumber<0)// check for errors on order selected from history
           {
            Print("Check sell conditions - error selecting orders from history  !");
            return;
           }
         //---
         if(recentClosedOrderType==0 && Sell_Ticket_4>0 && iOpenOrders_Sell<1)// last open erder was buy 
           {
            Print("Last order was Buy and Now Sell condition is met, so time to Open a Three Sell Order");

            if(Three_Sell_Orders()>0)
              {
               Print("Failed to open 3 sell orders with error : "+(string)GetLastError());
              }
            else
              {
               Print("The 3 Sell Orders are Opened");
               return;
              }
           }
         //---
         ticketNumber=History_Calling();
         iOpenOrders_Sell=CntOrd(OP_SELL);// update sell orders count
         iOpenOrders_Buy=CntOrd(OP_BUY);
         //--- if last exit order was sell or EA just started
         if((recentClosedOrderType==1 || (Sell_Ticket_3==0 && Sell_Ticket_4==0)) && iOpenOrders_Sell<1)
           {
            Print("The Sell Condition is Still Valid, so time to Open a Single Sell Order");
            One_Sell_Orders();
            if(CntOrd(OP_SELL)>0)// sell ticket 4 is now !=0
              {
               Print("A One_Sell Order was Opened");
               return;
              }
            else
              {
               Print("Failed to open one_sell order with error : "+(string)GetLastError());
              }
           }

        }
     }

   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int Three_Buy_Orders()
  {
   double OpenPrice=Ask;
   int count=3;

   double  dTakeProfitPrice_1,dTakeProfitPrice_2,dTakeProfitPrice_3;
   dStopLossPrice=NormalizeDouble(OpenPrice-StopLoss*dPip,Digits);

   dTakeProfitPrice_1 = NormalizeDouble(OpenPrice + TakeProfit_1 * dPip,Digits);
   dTakeProfitPrice_2 = NormalizeDouble(OpenPrice + TakeProfit_2 * dPip,Digits);
   dTakeProfitPrice_3 = NormalizeDouble(OpenPrice + TakeProfit_3 * dPip,Digits);
   if(count==3)
     {
      BuyOrder_1=OrderSend(Symbol(),iOrderType_Buy,LotSize,OpenPrice,Slippage,dStopLossPrice,dTakeProfitPrice_1,"Buy Order",MagicNumber,0,Blue);
      if(BuyOrder_1>0) //Checking if the order was opened or not
        {
         Print("First of 3_Buy_Orders Opened");
         count=count-1;
        }
      else
        {
         Print("Error in Opening First of 3_Buy_Orders : "+(string)GetLastError());
         return(count);//no orderes were opened
        }
     }

   if(count==2)
     {
      BuyOrder_2=OrderSend(Symbol(),iOrderType_Buy,LotSize,OpenPrice,Slippage,dStopLossPrice,dTakeProfitPrice_2,"Buy Order",MagicNumber,0,Blue);
      if(BuyOrder_2>0)
        {
         Print("Second of 3_Buy_Orders Opened");
         count=count-1;
        }
      else
        {
         Print("Error Opening Second of 3_Buy_Orders : "+(string)GetLastError());
         return(count);// one order open
        }
     }

   if(count==1)
     {
      BuyOrder_3=OrderSend(Symbol(),iOrderType_Buy,LotSize,OpenPrice,Slippage,dStopLossPrice,dTakeProfitPrice_3,"BuyOrder_3",MagicNumber,0,Blue);

      if(BuyOrder_3>0)
        {
         Print("Third of 3_Buy_Orders Opened, Ticket No:",BuyOrder_3);
         Buy_Ticket_3=BuyOrder_3;
         count=count-1;
        }
      else
        {
         Print("Error in Opening Third of 3_Buy_Orders : "+(string)GetLastError());
         return(count);// two orders open
        }
     }
   return(count);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int Three_Sell_Orders()
  {

   double OpenPrice=Bid;
   int count=3;
   double dTakeProfitPrice_1,dTakeProfitPrice_2,dTakeProfitPrice_3;
   dStopLossPrice=NormalizeDouble(OpenPrice+StopLoss*dPip,Digits);

   dTakeProfitPrice_1 = NormalizeDouble(OpenPrice - TakeProfit_1 * dPip,Digits);
   dTakeProfitPrice_2 = NormalizeDouble(OpenPrice - TakeProfit_2 * dPip,Digits);
   dTakeProfitPrice_3 = NormalizeDouble(OpenPrice - TakeProfit_3 * dPip,Digits);
   if(count==3)
     {
      SellOrder_1=OrderSend(Symbol(),iOrderType_Sell,LotSize,OpenPrice,Slippage,dStopLossPrice,dTakeProfitPrice_1,"Sell Order",MagicNumber,0,Red);

      if(SellOrder_1>0) //Checking if the order was opened or not
        {
         Print("First of 3_Sell_Order Opened");
         count=count-1;
        }
      else
        {
         Print("Error in opening Sell order 1"+(string)GetLastError());
        }
     }

   if(count==2)
     {
      SellOrder_2=OrderSend(Symbol(),iOrderType_Sell,LotSize,OpenPrice,Slippage,dStopLossPrice,dTakeProfitPrice_2,"Sell Order",MagicNumber,0,Red);

      if(SellOrder_2>0) //Checking if the order was opened or not
        {
         Print("Second of 3_Sell_Order Opened");
         count=count-1;
        }
      else
        {
         Print("Error in opening Sell order 2 : "+(string)GetLastError());
        }
     }

   if(count==1)
     {
      SellOrder_3=OrderSend(Symbol(),iOrderType_Sell,LotSize,OpenPrice,Slippage,dStopLossPrice,dTakeProfitPrice_3,"SellOrder_3",MagicNumber,0,Red);

      if(SellOrder_3>0) //Checking if the order was opened or not
        {
         Print("Third of 3_Sell_Order Opened, Ticket No:",SellOrder_3);
         Sell_Ticket_3=SellOrder_3;
         count=count-1;
        }
      else
        {
         Print("Error in opening Sell order 3 : "+(string)GetLastError());
        }
     }
   return(count);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int One_Buy_Orders()
  {
   double OpenPrice=Ask;
   int count=1;
   dStopLossPrice=NormalizeDouble(OpenPrice-StopLoss*dPip,Digits);
   double dTakeProfitPrice_3=NormalizeDouble(OpenPrice+TakeProfit_3*dPip,Digits);
//---
   if(count==1)
     {
      BuyOrder_4=OrderSend(Symbol(),0,LotSize,OpenPrice,Slippage,dStopLossPrice,dTakeProfitPrice_3,"Single Buy Order 4",MagicNumber,0,Blue);

      if(BuyOrder_4>0) //Checking if the order was opened or not
        {
         Print("Single Buy Order  Opened, Ticket No:",(string)BuyOrder_4);
         Buy_Ticket_4=BuyOrder_4;
         count=count-1;
        }
      else Print("Error in Opening Single Buy Order 4"+(string)GetLastError());
     }
   return(count);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int One_Sell_Orders()
  {

   double OpenPrice=Bid;
   int count=1;
   dStopLossPrice=NormalizeDouble(OpenPrice+StopLoss*dPip,Digits);
   double dTakeProfitPrice_3=NormalizeDouble(OpenPrice-TakeProfit_3*dPip,Digits);

   if(count==1)
     {
      SellOrder_4=OrderSend(Symbol(),OP_SELL,LotSize,OpenPrice,Slippage,dStopLossPrice,dTakeProfitPrice_3,"Single Sell Order 4",MagicNumber,0,Red);

      if(SellOrder_4>0) //Checking if the order was opened or not
        {
         Print("Single Sell Order Opened, Ticket No:",SellOrder_4);
         Sell_Ticket_4=SellOrder_4;
         count=count-1;
        }
      else Print("Error in opening Single Sell order 4"+(string)GetLastError());
     }
   return(count);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int CntOrd(int Type)
  {
//return number of orders matching the order type and Symbol() specific parameters. MagicNumber number param is optional
   int _CntOrd=0;
   for(int i=0;i<OrdersTotal();i++)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))//if order select fails
        {
         Print("Order select failed in CntOrd with error : "+(string)GetLastError());//tell me the error
         break;
        }
      // else if order select didn't fail        
      else
        {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
           {
            if(OrderType()==OP_BUY && Type==OP_BUY)_CntOrd++;
            if(OrderType()==OP_SELL && Type==OP_SELL)_CntOrd++;
           }
        }
     }// end for
   return(_CntOrd);
  }//end 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

bool CloseOrders(int orderType)
  {
   bool bClosed_=false;
   if(OrdersTotal()<1)return(true);// return true if no open orders

//---
   if(OrdersTotal()>0)
     {
      for(int Counter=0;Counter<OrdersTotal();Counter++)
        {
         if(!OrderSelect(Counter,SELECT_BY_POS,MODE_TRADES))//if order select fails
           {
            Print("Order select failed in close sell order with error : "+(string)GetLastError());//tell me the error
            break;
           }
         // else if order select didn't fail        
         else
           {
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
              {
               //--- close buy orders
               if(OrderType()==OP_BUY && orderType==OP_BUY)
                 {
                  cnt=0;
                  bClosed_=false;

                  //---

                  while(cnt<=30 && bClosed_==false)
                    {
                     RefreshRates();
                     if(IsTradeAllowed()==false) Print("Trade is not allowed or context is busy. Please wait");
                     else      // send request to close order
                       {
                        bClosed_=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),Slippage,Red);
                        cnt++;
                       }
                     //---
                     if(!bClosed_)
                       {
                        Print("Count "+(string)cnt+" ,Order close failed in close sell order with error : "+(string)GetLastError());
                        Sleep(100);
                       }

                    }//end while

                  //---
                  if(cnt==30 && bClosed_==false)
                    {
                     Alert("Failed to close order, ticket : "+(string)OrderTicket()+" error: "+(string)GetLastError());
                     break;
                    }
                 }//end close buy order

               //--- close sell
               if(OrderType()==OP_SELL && orderType==OP_SELL)
                 {
                  cnt=0;
                  bClosed_=false;
                  while(cnt<=30 && bClosed_==false)
                    {
                     RefreshRates();
                     if(IsTradeAllowed()==false) Print("Trade is not allowed or context is busy. Please wait");
                     else      // send request to close order
                       {
                        bClosed_=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),Slippage,Red);
                        cnt++;
                       }
                     //---
                     if(!bClosed_)
                       {
                        Print("Count "+(string)cnt+" ,Order close failed in close sell order with error : "+(string)GetLastError());
                        Sleep(100);
                       }
                    }//end while
                  //--- alert if fail to close order
                  if(cnt==30 && bClosed_==false)
                    {
                     Alert("Failed to close order, ticket : "+(string)OrderTicket()+" error: "+(string)GetLastError());
                     break;
                    }
                 }//end close sell order
              }
            else continue;//continue if symbol or magic don't match
           }// end else
        }// end for
     }
   if(orderType==OP_BUY && CntOrd(OP_BUY)<1)
     {
      Print("All buy orders closed");
      return(true);
     }
   if(orderType==OP_SELL && CntOrd(OP_SELL)<1)
     {
      Print("All sell orders closed");
      return(true);
     }
//---
   return(bClosed_);
  }//end bool CloseOrders(int Selltype)
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void Trailing_Stop()
  {
//---
   if(TrailingStart==0 || TrailingStop==0)return; // no trailig for zero settings
//---
   double vPoint,vSlippage,ticket,New_SL;
   ticket=0;
   if(Digits==3 || Digits==5)
     {vPoint=Point*10; vSlippage=Slippage*10;    }
   else
     {vPoint=Point; vSlippage=Slippage;}
   RefreshRates();

   for(int i=OrdersTotal()-1; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         Print("Error order select in trailing stop, error : "+(string)GetLastError());
        }
      else
        {
         if(OrderSymbol()==Symbol())
           {
            if(OrderMagicNumber()==MagicNumber)
              {
               if(OrderType()==OP_BUY)
                 {
                  if(OrderStopLoss()<OrderOpenPrice())
                    {
                     if(Bid>=OrderOpenPrice()+vPoint*BreakEvenStart)
                       {
                        ticket=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+vPoint*BreakEven,OrderTakeProfit(),0,Green);
                        New_SL=NormalizeDouble(OrderOpenPrice()+vPoint*BreakEven,Digits);
                        if(ticket>0)
                          {
                           Print("Break Even Activated: ",OrderSymbol(),": Modified SL",DoubleToString(New_SL,Digits),": Bid",DoubleToString(Bid,Digits));
                          }
                        else
                          {
                           Print("1 Error order modify in Trailing_Stop, error : "+(string)GetLastError());
                          }
                       }
                    }
                  else // if(OrderStopLoss()>OrderOpenPrice())
                    {
                     if(Bid-vPoint*TrailingStop>=OrderStopLoss())
                       {
                        ticket=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss()+vPoint*TrailingStep,OrderTakeProfit(),0,Green);
                        New_SL=OrderStopLoss()+vPoint*TrailingStep;
                        if(ticket>0)
                          {
                           Print("Trailed Stop Activated: ",OrderSymbol(),": Modified SL",DoubleToString(New_SL,Digits),": Bid",DoubleToString(Bid,Digits));
                          }
                        else
                          {
                           Print("2 Error order modify in Trailing_Stop, error : "+(string)GetLastError());
                          }
                       }
                    }// End else
                 }//End if(OrderType()==OP_BUY)

               if(OrderType()==OP_SELL)
                 {
                  if(OrderStopLoss()>OrderOpenPrice())
                    {
                     if(Ask<=OrderOpenPrice()-vPoint*BreakEvenStart)
                       {
                        ticket=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-vPoint*BreakEven,OrderTakeProfit(),0,Green);
                        New_SL=OrderOpenPrice()-vPoint*BreakEven;
                        if(ticket>0)
                          {
                           Print("Break Even Activated: ",OrderSymbol(),": Modified SL",DoubleToString(New_SL,Digits),": Ask",DoubleToString(Ask,Digits));
                          }
                        else
                          {
                           Print("3 Error order modify in Trailing_Stop, error : "+(string)GetLastError());
                          }
                       }
                    }
                  else
                    {
                     if(Ask+vPoint*TrailingStop<=OrderStopLoss())
                       {
                        ticket=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss()-vPoint*TrailingStep,OrderTakeProfit(),0,Green);
                        New_SL=OrderStopLoss()-vPoint*TrailingStep;
                        if(ticket>0)
                          {
                           Print("Trailed Stop Activated: ",OrderSymbol(),": Modified SL",DoubleToString(New_SL,Digits),": Ask",DoubleToString(Ask,Digits));
                          }
                        else
                          {
                           Print("4 Error order modify in Trailing_Stop, error : "+(string)GetLastError());
                          }
                       }
                    } //End else
                 }//if(OrderType()==OP_SELL)
              }
           }//End if(OrderSymbol()==Symbol())
        }//End if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
     }//End for ( int i=OrdersTotal()-1; i>=0; i--)
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int History_Calling()
  {
   if(OrdersHistoryTotal()<1)
     {
      static int x=0;
      if(x<1)Print("No orders in history");
      x++;
      return(0); // if no orders in history return ticket=zero
     }
   int i=0;
   recentClosedOrderTime=0;
   recentClosedTicket=-1;
   for(i=0;i<OrdersHistoryTotal();i++)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)) // if order select fails , print to let me know and take it from the top
        {
         Print("Orders select failed in History_Calling with error : "+IntegerToString(GetLastError(),0,0));
         break;
        }
      if(OrderType()==OP_BUY || OrderType()==OP_SELL)
        {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
           {
            myOrdersFromHistory++;
            if(OrderCloseTime()>recentClosedOrderTime)
              {
               recentClosedOrderTime=OrderCloseTime();                               //each time it finds a greater closing time 
               recentClosedTicket=OrderTicket();
               recentClosedOrderType=OrderType();                                   //overwrites the counter and the ticket number. 
              }
            else
              {
               continue;
              }
           }
         else
           {
            continue;
           }
        }
      else
        {
         continue;
        }
     }
//now it has the ticket number of the highest closing time in seconds since 1970
//you can get whatever info you want about that particular ticket.
   if(myOrdersFromHistory>0 && recentClosedTicket<0)
     {
      Print("No order selected in History_Calling,recentClosedTicket is"+(string)recentClosedTicket);
      return(recentClosedTicket);
     }
  else
   if(recentClosedTicket>-1)
     {
      if(OrderSelect(recentClosedTicket,SELECT_BY_TICKET))// when you select by ticket you do not need to specify mode trades or mode history.
        {
         string type="sell";
         if(OrderType()==OP_BUY)type="buy";// 0 is a buy and 1 is a sell
         string closeTime=TimeToString(OrderCloseTime());
         double closePrice=NormalizeDouble(OrderClosePrice(),Digits);
         Print("Ticket number ",recentClosedTicket," of type ",type," was closed at ",closeTime," at a price of: ",closePrice);
        }
      else Print("Orders select failed in History_Calling (2)with error : "+(string)GetLastError());
     }
   else
     {
      if(myOrdersFromHistory<1 && recentClosedTicket<0)
        {
         Print("No orders from this EA in History yet !");
         recentClosedTicket=0;
        }
     }
   return(recentClosedTicket);

  }
//+------------------------------------------------------------------+
